#include "AES.h"

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
}


void testECB_enc()
{
  uint8_t plaintext[16] = {0,};
  uint8_t ciphertext[16] = {0,};
  uint8_t key[16] = {0, };
  
  uint8_t expected_ciphertext[16] = {0x66, 0xe9, 0x4b, 0xd4, 0xef, 0x8a, 0x2c, 0x3b, 0x88, 0x4c, 0xfa, 0x59, 0xca, 0x34, 0x2b, 0x2e};
  
  uint8_t i;

  encryptECB(key, plaintext, 16, ciphertext);

  for (i = 0; i < 16; i++)
  {
    if (ciphertext[i] != expected_ciphertext[i])
    {
      Serial.println("Not OK");
      return;
    }
  }
  Serial.println("OK");  
}

void testECB_dec()
{
  uint8_t plaintext[16] = {0x1,};
  uint8_t ciphertext[16] = {0x66, 0xe9, 0x4b, 0xd4, 0xef, 0x8a, 0x2c, 0x3b, 0x88, 0x4c, 0xfa, 0x59, 0xca, 0x34, 0x2b, 0x2e};
  uint8_t key[16] = {0, };
  
  uint8_t expected_plaintext[16] = {0,};
  
  uint8_t i;

  decryptECB(key, ciphertext, 16, plaintext);

  for (i = 0; i < 16; i++)
  {
    if (plaintext[i] != expected_plaintext[i])
    {
      Serial.println("Not OK");
      return;
    }
  }
  Serial.println("OK");  
}

void testCBC_enc()
{
  uint8_t plaintext[16] = {0,};
  uint8_t ciphertext[16] = {0,};
  uint8_t key[16] = {0, };
  uint8_t iv[16] = {0, };
  
  uint8_t expected_ciphertext[16] = {0x66, 0xe9, 0x4b, 0xd4, 0xef, 0x8a, 0x2c, 0x3b, 0x88, 0x4c, 0xfa, 0x59, 0xca, 0x34, 0x2b, 0x2e};
  
  uint8_t i;

  encryptCBC(key, iv, plaintext, 16, ciphertext);

  for (i = 0; i < 16; i++)
  {
    if (ciphertext[i] != expected_ciphertext[i])
    {
      Serial.println("Not OK");
      return;
    }
  }
  Serial.println("OK");  
}

void testECB_enc2()
{
  uint8_t plaintext[32] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
      16, 17, 18, 19, 20, 21, 22, 23,  24, 25, 26, 27, 28, 29, 30, 31};
  uint8_t ciphertext[32] = {0,};
  uint8_t key[16] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
  
  uint8_t expected_ciphertext[32] = {0x0a, 0x94, 0x0b, 0xb5, 0x41, 0x6e, 0xf0, 0x45, 0xf1, 0xc3, 0x94, 0x58, 0xc6, 0x53, 0xea,
      0x5a,0x07, 0xfe, 0xef, 0x74, 0xe1, 0xd5, 0x03, 0x6e, 0x90, 0x0e, 0xee, 0x11, 0x8e, 0x94, 0x92, 0x93};
  
  uint8_t i;

  encryptECB(key, plaintext, 32, ciphertext);

  for (i = 0; i < 32; i++)
  {
    if (ciphertext[i] != expected_ciphertext[i])
    {
      Serial.println("Not OK");
      return;
    }
  }
  Serial.println("OK");  
}

void testECB_dec2()
{
  uint8_t plaintext[32] = {0,};
  uint8_t ciphertext[32] = {0x0a, 0x94, 0x0b, 0xb5, 0x41, 0x6e, 0xf0, 0x45, 0xf1, 0xc3, 0x94, 0x58, 0xc6, 0x53, 0xea,
      0x5a,0x07, 0xfe, 0xef, 0x74, 0xe1, 0xd5, 0x03, 0x6e, 0x90, 0x0e, 0xee, 0x11, 0x8e, 0x94, 0x92, 0x93};
  uint8_t key[16] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
  
  uint8_t expected_plaintext[32] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
      16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31};
  
  uint8_t i;

  decryptECB(key, ciphertext, 32, plaintext);

  for (i = 0; i < 32; i++)
  {
    if (plaintext[i] != expected_plaintext[i])
    {
      Serial.println("Not OK");
      return;
    }
  }
  Serial.println("OK");  
}

void testCBC_enc2()
{
  uint8_t plaintext[32] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
      16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31};
  uint8_t ciphertext[32] = {0,};
  uint8_t key[16] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
  uint8_t iv[16] = {0x60, 0xef, 0x17, 0x10, 0xd7, 0xcc, 0x28, 0xf8, 0x56, 0xbd, 0xe4, 0x8b, 0xa1, 0xce, 0xb0, 0x87};
  
  uint8_t expected_ciphertext[32] = {0xc5, 0x85, 0x22, 0x24, 0x4d, 0xf6, 0xef, 0xf9, 0xc8, 0x4c, 0xf1, 0xf8, 0x4e,
      0xc8, 0x60, 0x9a, 0x8d, 0xe9, 0x74, 0x7e, 0xb5, 0x09, 0x68, 0x7e, 0x13, 0x37, 0x02, 0x86, 0x14, 0xbe, 0x38, 0x93};
  
  uint8_t i;

  encryptCBC(key, iv, plaintext, 32, ciphertext);

  for (i = 0; i < 32; i++)
  {
    if (ciphertext[i] != expected_ciphertext[i])
    {
      Serial.println("Not OK");
      return;
    }
  }
  Serial.println("OK");  
}

void loop() {
  // put your main code here, to run repeatedly:

  testECB_enc();
  testECB_dec();
  testCBC_enc();
  testECB_enc2();
  testECB_dec2();
  testCBC_enc2();
  delay(10000);

}
